#!/usr/bin/env python
import setpath
import unittest
from bike import testdata
from rename import rename
from bike.testutils import trimLines, createSourceNodeAt, getMatchingASTNode
from bike.parsing.extended_ast import Root
from bike.query.getTypeOf import getTypeOf

class TestRenameTemporary(unittest.TestCase):
    def test_renamesSimpleReferencesGivenAssignment(self):
        src=trimLines("""
        def foo():
            a = 3
            print a
        """)
        srcAfter=trimLines("""
        def foo():
            b = 3
            print b
        """)
        root = createSourceNodeAt(Root(),src,"mymodule")
        sourcenode = root.getSource("mymodule")
        rename(sourcenode,2,4,"b")
        self.assertEqual(sourcenode.getSource(),srcAfter)



if __name__ == "__main__":
    unittest.main()
