#!/usr/bin/env python
import unittest
import setpath

from bike import testdata
from bike.testutils import *
import bike
from bike.refactor.test_renameFunction import RenameFunctionTests, RenameFunctionTests_importsFunction, FunctionTestdata
from bike.refactor.test_renameClass import RenameClassTests, RenameClassTests_importsClass, TheClassTestdata
from bike.refactor.test_renameMethod import RenameMethodTests, RenameMethodTests_ImportsClass, RenameMethodReferenceTests, RenameMethodReferenceTests_ImportsClass, RenameMethodAfterPromptTests, TestDoesntRenameMethodIfPromptReturnsFalse,MethodTestdata
from bike.refactor import test_extractMethod
import bikefacade
from bike import UndoStackEmptyException
from bike.query.getTypeOf import getTypeOf

'''
class TestRenameMethod(RenameMethodTests, unittest.TestCase):
    def renameMethod(self, src, fqn, newname):
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.renameMethod(tmpmodule+"."+fqn, newname)
            ctx.save()
            newsrc = readFile(tmpfile)
            return newsrc
        finally:
            deleteTmpTestFile()

class TestRenameMethod_importsClass(RenameMethodTests_ImportsClass, 
                                    unittest.TestCase):
    def renameMethod(self, src, fqn, newname):
        try:
            createPackageStructure(src, testdata.TheClass)
            ctx = bike.load(pkgstructureBasedir)
            ctx.renameMethod(fqn, newname)
            ctx.save()
            newsrc = readFile(os.path.join(pkgstructureBasedir, "foo.py"))
            return newsrc
        finally:
            removePackageStructure()

class TestRenameMethodReferences(RenameMethodReferenceTests, 
                                 unittest.TestCase):
    def renameMethod(self, src, fqn, newname):
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.renameMethod(tmpmodule+"."+fqn, newname)
            ctx.save()
            newsrc = readFile(tmpfile)
            return newsrc
        finally:
            deleteTmpTestFile()

class TestRenameMethodReferences_importsClass(RenameMethodReferenceTests_ImportsClass, 
                                              unittest.TestCase):
    def renameMethod(self, src, fqn, newname):
        try:
            createPackageStructure(src, testdata.TheClass)
            ctx = bike.load(pkgstructureBasedir)
            ctx.renameMethod(fqn, newname)
            ctx.save()
            newsrc = readFile(os.path.join(pkgstructureBasedir, "foo.py"))
            return newsrc
        finally:
            removePackageStructure()
'''

class TestRenameMethodAfterPrompt(RenameMethodAfterPromptTests, 
                                  unittest.TestCase):
    def callback(self, filename, line, colstart, colend):
        return 1

    def renameMethod(self, src, line, col, newname):
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.setRenameMethodPromptCallback(self.callback)
            ctx.renameByCoordinates(tmpfile,line,col,newname)
            ctx.save()
            newsrc = readFile(tmpfile)
            return newsrc
        finally:
            deleteTmpTestFile()

class TestDoesntRenameMethodIfPromptReturnsFalse(unittest.TestCase,
                                                 TestDoesntRenameMethodIfPromptReturnsFalse):

    def callback(self, filename, line, colstart, colend):
        return 0

    def renameMethod(self, src, line, col, newname):
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.setRenameMethodPromptCallback(self.callback)
            ctx.renameByCoordinates(tmpfile,line,col,newname)
            ctx.save()
            newsrc = readFile(tmpfile)
            return newsrc
        finally:
            deleteTmpTestFile()

'''

class TestRenameByCoordinates_OLD(RenameMethodTests,
                              unittest.TestCase):

    def getCoords(self,ctx,fqn):
        node = getTypeOf(ctx._getAST(),tmpmodule+"."+fqn)
        return node.getStartLine(), node.getColumnOfName()
    
    def renameMethod(self, src, fqn, newname):
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            line,col = self.getCoords(ctx,fqn)
            ctx.renameByCoordinates(os.path.abspath(tmpfile),line, col, newname)
            ctx.save()
            newsrc = readFile(tmpfile)
            return newsrc
        finally:
            deleteTmpTestFile()

    renameFunction = renameMethod
    renameClass = renameMethod

    def test_renamesSimpleReferencesGivenAssignment(self):
        src=trimLines("""
        def foo():
            a = 3
            print a
        """)
        srcAfter=trimLines("""
        def foo():
            b = 3
            print b
        """)


        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.renameByCoordinates(os.path.abspath(tmpfile),2,4,"b")
            ctx.save()
            newsrc = readFile(tmpfile)
            self.assertEqual(newsrc,srcAfter)
        finally:
            deleteTmpTestFile()

'''

'''
    def test_raisesExceptionIfCantFindNodeFromCoordinates(self):
        try:
            writeTmpTestFile("pass")
            ctx = bike.load(tmpfile)
            try:
                ctx.renameByCoordinates(os.path.abspath(tmpfile),1,0,"NewName")
                self.fail("shouldnt get to here")
            except bike.CouldntLocateASTNodeFromCoordinatesException:
                pass
        finally:
            deleteTmpTestFile()
'''


class TestRenameByCoordinates2(RenameMethodTests,RenameMethodReferenceTests, RenameClassTests,RenameFunctionTests,unittest.TestCase):
    def rename(self, src, line, col, newname):
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.renameByCoordinates(os.path.abspath(tmpfile),line,col,newname)
            ctx.save()
            newsrc = readFile(tmpfile)
            return newsrc
        finally:
            deleteTmpTestFile()


class TestRenameByCoordinatesWithDirectoryStructure(RenameClassTests_importsClass,
                                                    RenameFunctionTests_importsFunction,
                                                    RenameMethodTests_ImportsClass,
                                                    RenameMethodReferenceTests_ImportsClass,
                                                    unittest.TestCase):

    def renameClass(self, src, newname):
        try:
            createPackageStructure(src, TheClassTestdata)
            ctx = bike.load(pkgstructureBasedir)
            ctx.renameByCoordinates(pkgstructureFile2,1,6,newname)
            ctx.save()
            newsrc = readFile(pkgstructureFile1)
            return newsrc
        finally:
            removePackageStructure()


    def renameMethod(self, src, line, col, newname):
        try:
            createPackageStructure(src, MethodTestdata)
            ctx = bike.load(pkgstructureBasedir)
            ctx.renameByCoordinates(pkgstructureFile2,line,col,newname)
            ctx.save()
            newsrc = readFile(pkgstructureFile1)
            return newsrc
        finally:
            removePackageStructure()

    def renameFunction(self, src, newname):
        try:
            createPackageStructure(src, FunctionTestdata)
            ctx = bike.load(pkgstructureBasedir)
            ctx.renameByCoordinates(pkgstructureFile2,1,4,newname)
            ctx.save()
            newsrc = readFile(pkgstructureFile1)
            return newsrc
        finally:
            removePackageStructure()

'''
class TestLocateNode(unittest.TestCase):
    def test_findsFunctioninNestedFile(self):
        src = testdata.Function[1:]
        createPackageStructure("pass", src)
        ctx = bike.load(pkgstructureBasedir)
        removePackageStructure()
        filename = os.path.join(os.path.abspath(pkgstructureBasedir), "b", "bah.py")
        assert ctx._locateNode(filename, 1).fqn == "a.b.bah.theFunction"

    def test_returnsNoneIfCantFindNode(self):
        src = testdata.Function[1:]
        createPackageStructure("pass", src)
        ctx = bike.load(pkgstructureBasedir)
        removePackageStructure()
        filename = os.path.join(os.path.abspath(pkgstructureBasedir), "b", "bah.py")
        assert ctx._locateNode(filename, 2) == None

    def test_findsClassinNestedFile(self):
        src = trimLines("""
        class TheClass:
            pass
            
        raise TheClass, \"hello mum\"
        """)
        createPackageStructure("pass", src)
        ctx = bike.load(pkgstructureBasedir)
        removePackageStructure()
        filename = os.path.join(os.path.abspath(pkgstructureBasedir), "b", "bah.py")
        assert ctx._locateNode(filename, 1).fqn == "a.b.bah.TheClass"
'''

class TestReloadSource(unittest.TestCase):
    def test_changesASTToReflectNewSource(self):
        createPackageStructure("pass", "pass")
        ctx = bike.load(pkgstructureBasedir)
        removePackageStructure()
        createPackageStructure("pass", "class TheClass: pass")
        filename = os.path.join(os.path.abspath(pkgstructureBasedir), "b", "bah.py")
        # make sure it gets reloaded
        ctx._getSourceNode(filename).lastModified = 0   
        
        ctx.load(filename)        
        removePackageStructure()
        cls = getMatchingASTNode(ctx._getAST(), "Class", name="TheClass")
        assert cls.fqn == "a.b.bah.TheClass"

    def test_canRenameClassOnNewReloadedCode(self):
        srcBefore=trimLines("""
        import b.bah.TheClass

        def foo():
            a = b.bah.TheClass()
            a.theMethod()
        """)
        srcAfter=trimLines("""
        import b.bah.NewName

        def foo():
            a = b.bah.NewName()
            a.theMethod()
        """)

        createPackageStructure(srcBefore, "pass")
        ctx = bike.load(pkgstructureBasedir)
        removePackageStructure()
        createPackageStructure("pass", "class TheClass: pass")
        filename = pkgstructureFile2
        # make sure it gets reloaded
        ctx._getSourceNode(filename).lastModified = 0   
        ctx.load(filename)
        ctx.renameByCoordinates(filename,1,6,"NewName")
        removePackageStructure()
        src = getMatchingASTNode(ctx._getAST(), "Source",fqn="a.foo").getSource()
        self.assertEqual(srcAfter,src)


class Test_deducePackageOfFile(unittest.TestCase):
    def test_returnsEmptyStringIfFileNotInPackage(self):
        try:
            # this doesnt have __init__.py file, so
            # isnt package
            os.makedirs("a")
            writeFile(os.path.join("a","foo.py"),"pass")
            pkg = bikefacade._deducePackageOfFile(os.path.join("a","foo.py"))
            assert pkg == ""
        finally:
            os.remove(os.path.join("a","foo.py"))
            os.removedirs(os.path.join("a"))

    def test_returnsNestedPackage(self):
        try:
            os.makedirs(os.path.join("a","b"))
            writeFile(os.path.join("a","__init__.py"),"# ")
            writeFile(os.path.join("a","b","__init__.py"),"# ")
            writeFile(os.path.join("a","b","foo.py"),"pass")
            pkg = bikefacade._deducePackageOfFile(os.path.join("a","b","foo.py"))
            assert pkg == "a.b"
        finally:
            os.remove(os.path.join("a","__init__.py"))
            os.remove(os.path.join("a","b","__init__.py"))
            os.remove(os.path.join("a","b","foo.py"))
            os.removedirs(os.path.join("a","b"))
        
'''
class TestRenameMethodClientCallback(unittest.TestCase):

    class MockCallback(Mock):
        def callback(self, filename, line, colstart, colend):
            return 1
    
    def test_callbackGetsPassedTheFilenameCorrectly(self):
        src = trimLines("""
        class TheClass:
            def theMethod(self):
                pass

        a = myunfindableclass()

        a.theMethod()
        """)
        writeTmpTestFile(src)
        ctx = bike.load(tmpfile)
        deleteTmpTestFile()
        m = TestRenameMethodClientCallback.MockCallback()
        ctx.setRenameMethodPromptCallback(m.callback)
        ctx.renameMethod(tmpmodule+".TheClass.theMethod","NewName")
        assert m.mockCalledMethods["callback"][0].getParam(0) == os.path.abspath(tmpfile)

    def test_callbackGetsPassedTheCoordsCorrectly(self):
        writeTmpTestFile(trimLines("""
        class TheClass:
            def theMethod(self):
                pass
            
        a = myunfindableclass()
        
        a.theMethod()
        """))

        ctx = bike.load(tmpfile)
        deleteTmpTestFile()
        m = TestRenameMethodClientCallback.MockCallback()
        ctx.setRenameMethodPromptCallback(m.callback)
        ctx.renameMethod(tmpmodule+".TheClass.theMethod","NewName")
        self.assertEqual(m.mockCalledMethods["callback"][0].getParam(1),7)
        self.assertEqual(m.mockCalledMethods["callback"][0].getParam(2),2)
        self.assertEqual(m.mockCalledMethods["callback"][0].getParam(3),11)

class TestFacadeLoad(unittest.TestCase):
    def test_throwsExceptionIfTryToLoadANonPythonFile(self):
        try:
            writeFile("aoeuaoeuaoeu","hello")
            try:
                bike.load("aoeuaoeuaoeu")
                self.fail("should get to here")
            except bike.NotAPythonModuleOrPackageException:
                pass
        finally:
            os.remove("aoeuaoeuaoeu")
'''
class TestFacadeIsLoaded(unittest.TestCase):

    def test_isLoaded(self):
        try:
            writeTmpTestFile("")
            ctx = bike.load(tmpfile)
            self.failUnless(ctx.isLoaded(tmpfile))
            self.failIf(ctx.isLoaded(tmpfile + ".bak"))
        finally:
            deleteTmpTestFile()


class TestExtractMethod(test_extractMethod.TestExtractMethod):

    def test_extractsPass(self):
        srcBefore=trimLines("""
        class MyClass:
            def myMethod(self):
                pass
        """)

        srcAfter=trimLines("""
        class MyClass:
            def myMethod(self):
                self.newMethod()

            def newMethod(self):
                pass
        """)

        try:
            writeTmpTestFile(srcBefore)
            ctx = bike.load(tmpfile)
            ctx.extractMethod(os.path.abspath(tmpfile),3,8,3,12,"newMethod")
            ctx.save()
            self.assertEqual(readTmpTestFile(),srcAfter)
            ctx.undo()
            ctx.save()
            self.assertEqual(readTmpTestFile(),srcBefore)
        finally:
            deleteTmpTestFile()
        

class TestExtractFunction(test_extractMethod.TestExtractFunction):
    def test_extractsFunction(self):        
        srcBefore=trimLines("""
        def myFunction(): # comment
            a = 3
            c = a + 99
            b = c * 1
            print b
        """)
        srcAfter=trimLines("""
        def myFunction(): # comment
            a = 3
            b = newFunction(a)
            print b

        def newFunction(a):
            c = a + 99
            b = c * 1
            return b
        """)
        try:
            writeTmpTestFile(srcBefore)
            ctx = bike.load(tmpfile)
            ctx.extractMethod(os.path.abspath(tmpfile),3,4,4,13,"newFunction")
            ctx.save()
            self.assertEqual(readTmpTestFile(),srcAfter)
            ctx.undo()
            ctx.save()
            self.assertEqual(readTmpTestFile(),srcBefore)
        finally:
            deleteTmpTestFile()


class TestUndo(unittest.TestCase):
    def test_undoesTheTextOfASingleFile(self):
        try:
            src = trimLines("""
            class a:
                def foo(self):
                    pass
            """)
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.renameByCoordinates(tmpfile,2,8,"c")
            ctx.save()
            ctx.undo()
            ctx.save()
            newsrc = readFile(tmpfile)
            self.assertEqual(newsrc,src)
        finally:
            deleteTmpTestFile()
        

    def test_undoesTwoConsecutiveRefactorings(self):
        try:
            src = trimLines("""
            class a:
                def foo(self):
                    pass
            """)
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            ctx.renameByCoordinates(tmpfile,2,8,"c")
            ctx.save()
            
            newsrc1 = readFile(tmpfile)

            ctx.renameByCoordinates(tmpfile,2,8,"d")
            ctx.save()

            
            # 1st undo
            ctx.undo()
            ctx.save()
            newsrc = readFile(tmpfile)
            self.assertEqual(newsrc,
                             newsrc1)

            # 2nd undo
            ctx.undo()
            ctx.save()
            newsrc = readFile(tmpfile)
            self.assertEqual(newsrc,src)
        finally:
            deleteTmpTestFile()
        

    def test_undoesTheTextOfAFileTwice(self):
        for i in range(3):
            try:
                src = trimLines("""
                class foo:
                    def bah(self):
                        pass
                """)
                writeTmpTestFile(src)
                ctx = bike.load(tmpfile)
                ctx.renameByCoordinates(tmpfile,2,8,"c")
                ctx.save()
                ctx.undo()
                ctx.save()
                newsrc = readFile(tmpfile)
                self.assertEqual(newsrc,src)
                raisedexception=0
                try:
                    ctx.undo()
                except UndoStackEmptyException:
                    raisedexception=1
                assert raisedexception
            finally:
                deleteTmpTestFile()

    def test_undoesManualModificationsToFiles(self):
        try:
            writeTmpTestFile("class foo: pass")
            origsrc = readFile(tmpfile)
            ctx = bike.load(tmpfile)

            deleteTmpTestFile()
            writeTmpTestFile("pass")
            import os
            ctx.load(tmpfile)
            newsrc = readFile(tmpfile)
            assert newsrc != origsrc
            ctx.undo()
            ctx.save()
            newsrc = readFile(tmpfile)
            assert newsrc == origsrc
        finally:
            deleteTmpTestFile()


class TestGetFullyQualifiedNameOfScope(unittest.TestCase):
    def test_getsName(self):
        src = trimLines("""
        class TheClass:
            pass
        a = TheClass()
        """)
        try:
            createPackageStructure("pass",src)
            ctx = bike.load(pkgstructureBasedir)
            self.assertEqual(ctx.getFullyQualifiedNameOfScope(pkgstructureFile2,1),"a.b.bah.TheClass")
        finally:
            removePackageStructure()

class TestgetTypeOfExpression(unittest.TestCase):
    def test_getsTypeOfSimpleClassInstanceReference(self):
        src = trimLines("""
        from b.bah import TheClass
        a = TheClass()
        a.theMethod()
        """)
        try:
            createPackageStructure(src,testdata.TheClass)
            ctx = bike.load(pkgstructureBasedir)
            self.assertEqual(ctx.getTypeOfExpression(pkgstructureFile1,3,0,11).fqn,
                             "a.b.bah.TheClass.theMethod")
        finally:
            removePackageStructure()

    def test_getsTypeIfCoordsTheWrongWayRound(self):
        src = trimLines("""
        from b.bah import TheClass
        a = TheClass()
        a.theMethod()
        """)
        try:
            createPackageStructure(src,testdata.TheClass)
            ctx = bike.load(pkgstructureBasedir)
            self.assertEqual(ctx.getTypeOfExpression(pkgstructureFile1,3,11,0).fqn,
                             "a.b.bah.TheClass.theMethod")
        finally:
            removePackageStructure()



class TestGetReferencesToClass(unittest.TestCase):
    def test_returnsReferences(self):        
        src = trimLines("""
        class TheClass:
            pass
        a = TheClass()
        """)
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            refs = [refs for refs in ctx.findReferencesByCoordinates(tmpfile,1,6)]
            self.assertEqual(refs[0].filename,os.path.abspath(tmpfile))
            self.assertEqual(refs[0].lineno,3)
            assert hasattr(refs[0],"confidence")
        finally:
            deleteTmpTestFile()


class TestFindDefinitionByCoordinates(unittest.TestCase):
    def test_findsClassRef(self):
        src=trimLines("""
        class TheClass:
            pass
        a = TheClass()
        """)
        try:
            writeTmpTestFile(src)
            ctx = bike.load(tmpfile)
            defn = [x for x in
                    ctx.findDefinitionByCoordinates(tmpfile,3,6)]
            assert defn[0].filename == os.path.abspath(tmpfile)
            assert defn[0].lineno == 1
            assert defn[0].confidence == 100
        finally:
            deleteTmpTestFile()


if __name__ == "__main__":
    unittest.main()
